--- u-boot-2011.06_original/common/cmd_simg.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cmd_simg.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,327 @@
+/*
+ * Copyright (C) 2010 The Android Open Source Project
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#include <common.h>
+#include <command.h>
+
+#include <mmc.h>
+#include <malloc.h>
+#include <linux/ctype.h>
+
+typedef struct sparse_header {
+  __le32	magic;		/* 0xed26ff3a */
+  __le16	major_version;	/* (0x1) - reject images with higher major versions */
+  __le16	minor_version;	/* (0x0) - allow images with higer minor versions */
+  __le16	file_hdr_sz;	/* 28 bytes for first revision of the file format */
+  __le16	chunk_hdr_sz;	/* 12 bytes for first revision of the file format */
+  __le32	blk_sz;		/* block size in bytes, must be a multiple of 4 (4096) */
+  __le32	total_blks;	/* total blocks in the non-sparse output image */
+  __le32	total_chunks;	/* total chunks in the sparse input image */
+  __le32	image_checksum; /* CRC32 checksum of the original data, counting "don't care" */
+				/* as 0. Standard 802.3 polynomial, use a Public Domain */
+				/* table implementation */
+} sparse_header_t;
+
+#define SPARSE_HEADER_MAGIC	0xed26ff3a
+
+#define CHUNK_TYPE_RAW		0xCAC1
+#define CHUNK_TYPE_FILL		0xCAC2
+#define CHUNK_TYPE_DONT_CARE	0xCAC3
+#define CHUNK_TYPE_CRC32    0xCAC4
+
+typedef struct chunk_header {
+  __le16	chunk_type;	/* 0xCAC1 -> raw; 0xCAC2 -> fill; 0xCAC3 -> don't care */
+  __le16	reserved1;
+  __le32	chunk_sz;	/* in blocks in output image */
+  __le32	total_sz;	/* in bytes of chunk input file including chunk header and data */
+} chunk_header_t;
+
+/* Following a Raw or Fill or CRC32 chunk is data.
+ *  For a Raw chunk, it's the data in chunk_sz * blk_sz.
+ *  For a Fill chunk, it's 4 bytes of the fill data.
+ *  For a CRC32 chunk, it's 4 bytes of CRC32
+ */
+
+#define SPARSE_HEADER_MAJOR_VER 1
+
+static u32 mem_addr;
+static u32 mmc_addr;
+
+static block_dev_desc_t *mmc_desc;
+
+#define COPY_BUF_SIZE (1024*1024)
+static u8 *copybuf;
+
+/*
+ * A function that calculates the CRC-32 based on the table above is
+ * given below for documentation purposes. An equivalent implementation
+ * of this function that's actually used in the kernel can be found
+ * in sys/libkern.h, where it can be inlined.
+ */
+
+static u32 sparse_crc32(u32 crc_in, const void *buf, int size)
+{
+	return crc32(crc_in, buf, size);
+}
+
+static int read_all(void *buf, size_t len)
+{
+	memcpy(buf, (void *)mem_addr, len);
+	mem_addr += len;
+	return len;
+}
+
+static int write_all(void *buf, size_t len)
+{
+	u32 start = mmc_addr / mmc_desc->blksz;
+	u32 blksz = len / mmc_desc->blksz;
+
+	mmc_desc->block_write(mmc_desc->dev, start, blksz, buf);
+	mmc_addr += len;
+	return len;
+}
+
+static void lseek_mem(u32 offset)
+{
+	mem_addr += offset;
+}
+
+static void lseek_mmc(u32 offset)
+{
+	mmc_addr += offset;
+}
+
+int process_raw_chunk(u32 blocks, u32 blk_sz, u32 *crc32)
+{
+	u64 len = blocks * blk_sz;
+	int ret;
+	int chunk;
+
+	while (len) {
+		chunk = (len > COPY_BUF_SIZE) ? COPY_BUF_SIZE : len;
+		ret = read_all(copybuf, chunk);
+		if (ret != chunk) {
+			fprintf(stderr, "read returned an error copying a raw chunk: %d %d\n",
+					ret, chunk);
+			return(-1);
+		}
+		*crc32 = sparse_crc32(*crc32, copybuf, chunk);
+		ret = write_all(copybuf, chunk);
+		if (ret != chunk) {
+			fprintf(stderr, "write returned an error copying a raw chunk\n");
+			return(-1);
+		}
+		len -= chunk;
+	}
+
+	return blocks;
+}
+
+
+int process_fill_chunk(u32 blocks, u32 blk_sz, u32 *crc32)
+{
+	u64 len = blocks * blk_sz;
+	int ret;
+	int chunk;
+	u32 fill_val = 0;
+	u32 *fillbuf;
+	unsigned int i;
+
+	/* Fill copy_buf with the fill value */
+	ret = read_all(&fill_val, sizeof(fill_val));
+	fillbuf = (u32 *)copybuf;
+	for (i = 0; i < (COPY_BUF_SIZE / sizeof(fill_val)); i++) {
+		fillbuf[i] = fill_val;
+	}
+
+	while (len) {
+		chunk = (len > COPY_BUF_SIZE) ? COPY_BUF_SIZE : len;
+		*crc32 = sparse_crc32(*crc32, copybuf, chunk);
+		ret = write_all(copybuf, chunk);
+		if (ret != chunk) {
+			fprintf(stderr, "write returned an error copying a raw chunk\n");
+			return(-1);
+		}
+		len -= chunk;
+	}
+
+	return blocks;
+}
+
+int process_skip_chunk(u32 blocks, u32 blk_sz, u32 *crc32)
+{
+	/* len needs to be 64 bits, as the sparse file specifies the skip amount
+	 * as a 32 bit value of blocks.
+	 */
+	u32 len = blocks * blk_sz;
+	lseek_mmc(len);
+
+	return blocks;
+}
+
+int process_crc32_chunk(u32 crc32)
+{
+	u32 file_crc32;
+	int ret;
+
+	ret = read_all(&file_crc32, 4);
+	if (ret != 4) {
+		fprintf(stderr, "read returned an error copying a crc32 chunk\n");
+		return(-1);
+	}
+
+	if (file_crc32 != crc32) {
+		fprintf(stderr, "computed crc32 of 0x%8.8x, expected 0x%8.8x\n",
+			 crc32, file_crc32);
+		return(-1);
+	}
+
+	return 0;
+}
+
+static int simg_mmc_write(int dev, char *memstr, char *mmcstr)
+{
+	unsigned int i;
+	struct mmc *mmc = find_mmc_device(dev);
+	sparse_header_t sparse_header;
+	chunk_header_t chunk_header;
+	u32 crc32 = 0;
+	u32 total_blocks = 0;
+	int ret;
+
+	mmc_desc = &mmc->block_dev;
+	mem_addr = simple_strtoul(memstr, NULL, 16);
+	mmc_addr = simple_strtoul(mmcstr, NULL, 16) * mmc_desc->blksz;
+
+	copybuf = malloc(COPY_BUF_SIZE);
+	if (!copybuf) {
+		fprintf(stderr, "Error mallocing buffer\n");
+		return(-1);
+	}
+
+	ret = read_all(&sparse_header, sizeof(sparse_header));
+	if (ret != sizeof(sparse_header)) {
+		fprintf(stderr, "Error reading sparse file header\n");
+		return(-1);
+	}
+
+	if (sparse_header.magic != SPARSE_HEADER_MAGIC) {
+		fprintf(stderr, "Bad magic\n");
+		return(-1);
+	}
+
+	if (sparse_header.major_version != SPARSE_HEADER_MAJOR_VER) {
+		fprintf(stderr, "Unknown major version number\n");
+		return(-1);
+	}
+
+	if (sparse_header.file_hdr_sz > sizeof(sparse_header_t)) {
+		/* Skip the remaining bytes in a header that is longer than
+		 * we expected.
+		 */
+		lseek_mem(sparse_header.file_hdr_sz - sizeof(sparse_header_t));
+	}
+
+	for (i=0; i<sparse_header.total_chunks; i++) {
+		ret = read_all(&chunk_header, sizeof(chunk_header));
+		if (ret != sizeof(chunk_header)) {
+			fprintf(stderr, "Error reading chunk header\n");
+			return(-1);
+		}
+
+		if (sparse_header.chunk_hdr_sz > sizeof(chunk_header_t)) {
+			/* Skip the remaining bytes in a header that is longer than
+			 * we expected.
+			 */
+			lseek_mem(sparse_header.chunk_hdr_sz - sizeof(chunk_header_t));
+		}
+
+		switch (chunk_header.chunk_type) {
+		    case CHUNK_TYPE_RAW:
+			if (chunk_header.total_sz != (sparse_header.chunk_hdr_sz +
+				 (chunk_header.chunk_sz * sparse_header.blk_sz)) ) {
+				fprintf(stderr, "Bogus chunk size for chunk %d, type Raw\n", i);
+				return(-1);
+			}
+			total_blocks += process_raw_chunk(chunk_header.chunk_sz, sparse_header.blk_sz, &crc32);
+			break;
+		    case CHUNK_TYPE_FILL:
+			if (chunk_header.total_sz != (sparse_header.chunk_hdr_sz + sizeof(u32)) ) {
+				fprintf(stderr, "Bogus chunk size for chunk %d, type Fill\n", i);
+				return(-1);
+			}
+			total_blocks += process_fill_chunk(chunk_header.chunk_sz, sparse_header.blk_sz, &crc32);
+			break;
+		    case CHUNK_TYPE_DONT_CARE:
+			if (chunk_header.total_sz != sparse_header.chunk_hdr_sz) {
+				fprintf(stderr, "Bogus chunk size for chunk %d, type Dont Care\n", i);
+				return(-1);
+			}
+			total_blocks += process_skip_chunk(chunk_header.chunk_sz, sparse_header.blk_sz, &crc32);
+			break;
+		    case CHUNK_TYPE_CRC32:
+			process_crc32_chunk(crc32);
+			break;
+		    default:
+			fprintf(stderr, "Unknown chunk type 0x%4.4x\n", chunk_header.chunk_type);
+		}
+
+	}
+
+	if (sparse_header.total_blks != total_blocks) {
+		fprintf(stderr, "Wrote %d blocks, expected to write %d blocks\n",
+			 total_blocks, sparse_header.total_blks);
+		return(-1);
+	}
+
+	return(0);
+}
+
+int do_simg(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+	int ret = CMD_RET_SUCCESS;
+	int dev = 0;
+	char *pstr;
+
+	if (argc < 6)
+		return CMD_RET_USAGE;
+
+	/* command: 'write' */
+	if ((strcmp(argv[1], "write") == 0) && (argc == 6)) {
+		/* device: 'mmc' */
+		if (strcmp(argv[2], "mmc") == 0) {
+			/* check if 'dev' is a number */
+			for (pstr = argv[3]; *pstr != '\0'; pstr++)
+				if (!isdigit(*pstr)) {
+					printf("'%s' is not a number\n",
+						argv[3]);
+					return CMD_RET_USAGE;
+				}
+			dev = (int)simple_strtoul(argv[3], NULL, 10);
+			/* write to mmc */
+			if (simg_mmc_write(dev, argv[4], argv[5]))
+				return CMD_RET_FAILURE;
+		}
+	} else {
+		return CMD_RET_USAGE;
+	}
+	return ret;
+}
+
+U_BOOT_CMD(simg, CONFIG_SYS_MAXARGS, 1, do_simg,
+	"Write Simg Image",
+	"<command> <interface> <simg addr> <mmc addr>\n"
+);
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_update.c u-boot-2011.06/common/cmd_update.c
